import { AchievementService } from '../../service/platform/achievement.service';
import { CVO_achievement, FVO_achievement, QVO_achievement, UVAO_achievement } from '../../interface/platform/achievement.interface';
import { ApiResponse, ApiTags, ApiQuery } from '@midwayjs/swagger';
import { Validate } from '@midwayjs/validate';
import { BaseController } from '../../frame/BaseController';
import { ErrorCode, ServiceError } from '../../error/service.error';
import { omit, pick } from 'lodash';
import { Controller, Inject, Get, Param, Post, Body, Del, Query } from '@midwayjs/core';
import { Context } from '@midwayjs/koa';
const namePrefix = '成果';
@ApiTags(['成果'])
@Controller('/achievement', { tagName: namePrefix })
export class AchievementController implements BaseController {
  @Inject()
  service: AchievementService;

  @Inject()
  ctx: Context;

  @Get('/')
  @ApiTags('列表查询')
  @ApiQuery({ name: 'query' })
  @ApiResponse({ type: QVO_achievement })
  async index(@Query() query: object) {
    const qobj = omit(query, ['skip', 'limit']);
    const others = pick(query, ['skip', 'limit']);
    const qbr = this.service.queryBuilder(qobj);
    const result = await this.service.query(qbr, others);
    return result;
  }

  @Get('/:id')
  @ApiTags('单查询')
  @ApiResponse({ type: FVO_achievement })
  async fetch(@Param('id') id: number) {
    const qbr = this.service.queryBuilder({ id });
    const data = await this.service.fetch(qbr);
    const result = new FVO_achievement(data);
    return result;
  }

  @Post('/', { routerName: `创建${namePrefix}` })
  @ApiTags('创建数据')
  @Validate()
  @ApiResponse({ type: CVO_achievement })
  async create(@Body() data: object) {
    const dbData = await this.service.create(data);
    const result = new CVO_achievement(dbData);
    return result;
  }

  @Post('/:id', { routerName: `修改${namePrefix}` })
  @ApiTags('修改数据')
  @Validate()
  @ApiResponse({ type: UVAO_achievement })
  async update(@Param('id') id: number, @Body() data: object) {
    if (!id) throw new ServiceError(ErrorCode.ID_NOT_FOUND);
    const result = await this.service.update({ id }, data);
    return result;
  }

  @Del('/:id', { routerName: `删除${namePrefix}` })
  @ApiTags('删除数据')
  @Validate()
  async delete(@Param('id') id: number) {
    if (!id) throw new ServiceError(ErrorCode.ID_NOT_FOUND);
    const result = await this.service.delete({ id });
    return result;
  }

  @Get('/detail/:id')
  @ApiResponse({ type: FVO_achievement })
  async detail(@Param('id') id: string) {
    const data = await this.service.detail(id);
    return data;
  }

  @Get('/list')
  async list() {
    const list = await this.service.list(this.ctx.query);
    const data = list.data;
    const total = list.total;
    return { data, total };
  }
}
